/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO
 *  com.deepexi.scd.common.enums.BaseExceptionEnum
 *  com.deepexi.scd.common.enums.ExceptionEnum
 *  com.deepexi.scd.common.enums.business.CalculateItemValueTypeEnum
 *  com.deepexi.scd.common.exceptions.BusinessException
 *  com.deepexi.scd.common.extensions.ExNumeric
 *  com.google.api.client.util.Lists
 *  jodd.util.StringUtil
 *  org.apache.commons.collections.CollectionUtils
 */
package com.deepexi.scd.calculate.covert;

import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemVO;
import com.deepexi.scd.calculate.domain.vo.CalculateLayoutItemValueVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO;
import com.deepexi.scd.common.enums.BaseExceptionEnum;
import com.deepexi.scd.common.enums.ExceptionEnum;
import com.deepexi.scd.common.enums.business.CalculateItemValueTypeEnum;
import com.deepexi.scd.common.exceptions.BusinessException;
import com.deepexi.scd.common.extensions.ExNumeric;
import com.google.api.client.util.Lists;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Comparator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.Optional;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import jodd.util.StringUtil;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;

public class ReportTemplateCovert {
    public static final String ADD = "ADD";
    public static final String SUBTRACT = "SUBTRACT";
    public static final String MULTIPLY = "MULTIPLY";
    public static final String DIVIDE = "DIVIDE";

    private ReportTemplateCovert() {
    }

    public static BigDecimal convert2BigDecimal(String value) {
        if (StringUtils.isBlank(value)) {
            return BigDecimal.ZERO;
        }
        return new BigDecimal(value.replace(",", ""));
    }

    public static List<CalculateReportLayoutObjectVO> getTableItems(List<CalculateReportLayoutObjectVO> all, List<String> edgeNames, List<String> metaNames, List<String> tableNames, String consumeColumn, String factorColumn, String columnName) {
        List<CalculateLayoutItemVO> collect = ReportTemplateCovert.getFilterItem(all, edgeNames, metaNames, tableNames);
        if (StringUtils.isNotBlank(consumeColumn) && StringUtils.isNotBlank(factorColumn)) {
            ReportTemplateCovert.calculate(collect, consumeColumn, factorColumn, columnName, MULTIPLY);
        }
        Map<String, List<CalculateLayoutItemVO>> tableMap = collect.stream().collect(Collectors.groupingBy(CalculateLayoutItemVO::getTableName));
        return tableNames.stream().map(tableName -> {
            List calculateLayoutItems = (List)tableMap.get(tableName);
            CalculateReportLayoutObjectVO calculateReportLayoutObjectVO = new CalculateReportLayoutObjectVO();
            calculateReportLayoutObjectVO.setObjectName(tableName);
            calculateReportLayoutObjectVO.setObjectType("TABLE");
            if (CollectionUtils.isEmpty((Collection)calculateLayoutItems)) {
                calculateReportLayoutObjectVO.setItemList((List)Lists.newArrayList());
            } else {
                calculateReportLayoutObjectVO.setItemList(calculateLayoutItems);
            }
            return calculateReportLayoutObjectVO;
        }).collect(Collectors.toList());
    }

    public static List<CalculateReportLayoutObjectVO> aggregationTable(Map<String, List<String>> aggrMap, List<CalculateReportLayoutObjectVO> tableItems) {
        ArrayList result = Lists.newArrayList();
        Map<String, List> itemMap = tableItems.stream().collect(Collectors.toMap(CalculateReportLayoutObjectVO::getObjectName, CalculateReportLayoutObjectVO::getItemList));
        aggrMap.forEach((key, value) -> {
            CalculateReportLayoutObjectVO item = new CalculateReportLayoutObjectVO();
            item.setObjectName(key);
            List collect = value.stream().flatMap(tableName -> {
                List calculateLayoutItems = (List)itemMap.get(tableName);
                if (CollectionUtils.isEmpty((Collection)calculateLayoutItems)) {
                    return Stream.empty();
                }
                return calculateLayoutItems.stream();
            }).collect(Collectors.toList());
            item.setItemList(collect);
            result.add(item);
        });
        return result;
    }

    public static List<CalculateLayoutItemVO> getFilterItem(List<CalculateReportLayoutObjectVO> all, List<String> edgeNames, List<String> metaNames, List<String> tableNames) {
        if (CollectionUtils.isEmpty(all)) {
            return Lists.newArrayList();
        }
        return all.stream().filter(item -> edgeNames.contains(item.getUpperObjectName())).filter(item -> metaNames.contains(item.getObjectName())).flatMap(item -> item.getItemList().stream()).filter(item -> tableNames.contains(item.getTableName())).collect(Collectors.toList());
    }

    public static void calculate(List<CalculateLayoutItemVO> collect, String majorColumn, String subColumn, String columnName, String operation) {
        collect.forEach(item -> {
            List itemValueList = item.getItemValueList();
            if (CollectionUtils.isEmpty((Collection)itemValueList)) {
                return;
            }
            Optional<CalculateLayoutItemValueVO> majorOption = itemValueList.stream().filter(value -> majorColumn.equals(value.getValueCode())).findFirst();
            Optional<CalculateLayoutItemValueVO> subOption = itemValueList.stream().filter(value -> subColumn.equals(value.getValueCode())).findFirst();
            BigDecimal majorNum = majorOption.isPresent() ? ReportTemplateCovert.convert2BigDecimal(majorOption.get().getValue()) : BigDecimal.ZERO;
            BigDecimal subNum = subOption.isPresent() ? ReportTemplateCovert.convert2BigDecimal(subOption.get().getValue()) : BigDecimal.ZERO;
            BigDecimal value2 = BigDecimal.ZERO;
            CalculateLayoutItemValueVO column = new CalculateLayoutItemValueVO();
            switch (operation) {
                case "ADD": {
                    value2 = majorNum.add(subNum);
                    break;
                }
                case "MULTIPLY": {
                    value2 = majorNum.multiply(subNum);
                    break;
                }
                case "SUBTRACT": {
                    value2 = majorNum.subtract(subNum);
                    break;
                }
                case "DIVIDE": {
                    if (subNum.equals(BigDecimal.ZERO)) break;
                    value2 = majorNum.divide(subNum, 10, 4);
                    break;
                }
                default: {
                    throw new BusinessException((BaseExceptionEnum)ExceptionEnum.CALCULATE_NOT_SUPPORT);
                }
            }
            column.setValue(ExNumeric.formatValue((BigDecimal)value2, (Integer)5));
            column.setOriginValue(ExNumeric.formatValue((BigDecimal)value2, (Integer)10));
            column.setValueCode(columnName);
            itemValueList.add(column);
        });
    }

    public static List<CalculateReportLayoutTotalVO> covertTotalList(String totalType, List<String> totalNames, Map<String, String> map, List<CalculateReportLayoutTotalVO> totalList) {
        Map totalMap = totalList.stream().collect(Collectors.toMap(CalculateReportLayoutTotalVO::getTotalName, Function.identity(), (a, b) -> a));
        return totalNames.stream().map(name -> {
            CalculateReportLayoutTotalVO calculateReportLayoutTotalVO = (CalculateReportLayoutTotalVO)totalMap.get(name);
            if (Objects.isNull(calculateReportLayoutTotalVO)) {
                calculateReportLayoutTotalVO = new CalculateReportLayoutTotalVO();
                calculateReportLayoutTotalVO.setTotalValueStr("0");
                calculateReportLayoutTotalVO.setTotalType(totalType);
            }
            calculateReportLayoutTotalVO.setTotalValueStr(ExNumeric.stepFormatValue((String)calculateReportLayoutTotalVO.getTotalValueStr(), (Integer)2));
            String newName = (String)map.get(name);
            if (StringUtils.isNotBlank(newName)) {
                calculateReportLayoutTotalVO.setTotalName(newName);
            }
            return calculateReportLayoutTotalVO;
        }).collect(Collectors.toList());
    }

    public static List<CalculateReportLayoutObjectVO> getTarget(CalculateReportLayoutObjectVO calculateReportLayoutObjectVO) {
        List itemList = calculateReportLayoutObjectVO.getItemList();
        if (CollectionUtils.isEmpty((Collection)itemList)) {
            return Lists.newArrayList();
        }
        ArrayList result = Lists.newArrayList();
        CalculateLayoutItemVO calculateLayoutItem = (CalculateLayoutItemVO)itemList.get(0);
        if (StringUtil.isBlank((CharSequence)calculateLayoutItem.getTableTargetName())) {
            calculateReportLayoutObjectVO.setObjectType("TABLE_TARGET");
            result.add(calculateReportLayoutObjectVO);
        } else {
            Map map = itemList.stream().sorted(Comparator.comparing(CalculateLayoutItemVO::getTableTargetId)).collect(Collectors.groupingBy(CalculateLayoutItemVO::getTableTargetName, LinkedHashMap::new, Collectors.toList()));
            map.forEach((key, items) -> {
                CalculateReportLayoutObjectVO objectVO = new CalculateReportLayoutObjectVO();
                objectVO.setItemList(items);
                objectVO.setObjectName(key);
                objectVO.setObjectType("TABLE_TARGET");
                result.add(objectVO);
            });
        }
        return result;
    }

    public static List<CalculateLayoutItemValueVO> valueCodeTotal(List<CalculateLayoutItemVO> itemList) {
        Map<String, List<CalculateLayoutItemValueVO>> collect = ReportTemplateCovert.groupByValueCode(itemList);
        ArrayList itemValues = Lists.newArrayList();
        collect.forEach((key, value) -> {
            CalculateLayoutItemValueVO itemValueVO = (CalculateLayoutItemValueVO)value.get(0);
            BigDecimal sum = BigDecimal.ZERO;
            if (CalculateItemValueTypeEnum.CONSUMPTION.getKey().equals(itemValueVO.getValueType())) {
                sum = value.stream().map(itemValue -> ReportTemplateCovert.convert2BigDecimal(itemValue.getOriginValue())).reduce(BigDecimal.ZERO, BigDecimal::add);
            }
            if (CalculateItemValueTypeEnum.FACTOR.getKey().equals(itemValueVO.getValueType())) {
                sum = value.stream().map(itemValue -> ReportTemplateCovert.convert2BigDecimal(itemValue.getOriginValue())).reduce(BigDecimal.ZERO, BigDecimal::add).divide(new BigDecimal(value.size()), 10, 4);
            }
            itemValueVO.setValue(ExNumeric.stepFormatValue((BigDecimal)sum, (Integer)5));
            itemValueVO.setOriginValue(ExNumeric.formatValue((BigDecimal)sum, (Integer)10));
            itemValues.add(itemValueVO);
        });
        return itemValues;
    }

    public static Map<String, List<CalculateLayoutItemValueVO>> groupByValueCode(List<CalculateLayoutItemVO> list) {
        return list.stream().flatMap(itemVO -> itemVO.getItemValueList().stream()).filter(itemValueVO -> !CalculateItemValueTypeEnum.CALCULATE_ITEM.getKey().equals(itemValueVO.getValueType())).collect(Collectors.groupingBy(CalculateLayoutItemValueVO::getValueCode));
    }
}

